/*
 * Browshot API
 * Take screenshots of any website in real time
 *
 * OpenAPI spec version: 1.16.0
 * Contact: support@browshot.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * Batch
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2017-01-29T05:18:22.088Z")
public class Batch {
  @SerializedName("id")
  private Integer id = null;

  /**
   * status of the request - \"in_queue\", \"processing\", \"finished\", \"error\"
   */
  public enum StatusEnum {
    @SerializedName("in_queue")
    IN_QUEUE("in_queue"),
    
    @SerializedName("processing")
    PROCESSING("processing"),
    
    @SerializedName("finished")
    FINISHED("finished"),
    
    @SerializedName("error")
    ERROR("error");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("status")
  private StatusEnum status = null;

  @SerializedName("started")
  private Integer started = null;

  @SerializedName("finished")
  private Integer finished = null;

  @SerializedName("count")
  private Integer count = null;

  @SerializedName("processed")
  private Integer processed = null;

  @SerializedName("failed")
  private Integer failed = null;

  @SerializedName("urls")
  private List<String> urls = new ArrayList<String>();

  public Batch id(Integer id) {
    this.id = id;
    return this;
  }

   /**
   * batch ID
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "batch ID")
  public Integer getId() {
    return id;
  }

  public void setId(Integer id) {
    this.id = id;
  }

  public Batch status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * status of the request - \"in_queue\", \"processing\", \"finished\", \"error\"
   * @return status
  **/
  @ApiModelProperty(example = "null", value = "status of the request - \"in_queue\", \"processing\", \"finished\", \"error\"")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public Batch started(Integer started) {
    this.started = started;
    return this;
  }

   /**
   * time of processing (UNIX timestamp)
   * @return started
  **/
  @ApiModelProperty(example = "null", value = "time of processing (UNIX timestamp)")
  public Integer getStarted() {
    return started;
  }

  public void setStarted(Integer started) {
    this.started = started;
  }

  public Batch finished(Integer finished) {
    this.finished = finished;
    return this;
  }

   /**
   * time of batch completed (UNIX timestamp)
   * @return finished
  **/
  @ApiModelProperty(example = "null", value = "time of batch completed (UNIX timestamp)")
  public Integer getFinished() {
    return finished;
  }

  public void setFinished(Integer finished) {
    this.finished = finished;
  }

  public Batch count(Integer count) {
    this.count = count;
    return this;
  }

   /**
   * number of unique URLs in the batch
   * @return count
  **/
  @ApiModelProperty(example = "null", value = "number of unique URLs in the batch")
  public Integer getCount() {
    return count;
  }

  public void setCount(Integer count) {
    this.count = count;
  }

  public Batch processed(Integer processed) {
    this.processed = processed;
    return this;
  }

   /**
   * number of screenshots finishe
   * @return processed
  **/
  @ApiModelProperty(example = "null", value = "number of screenshots finishe")
  public Integer getProcessed() {
    return processed;
  }

  public void setProcessed(Integer processed) {
    this.processed = processed;
  }

  public Batch failed(Integer failed) {
    this.failed = failed;
    return this;
  }

   /**
   * number of screenshots failed
   * @return failed
  **/
  @ApiModelProperty(example = "null", value = "number of screenshots failed")
  public Integer getFailed() {
    return failed;
  }

  public void setFailed(Integer failed) {
    this.failed = failed;
  }

  public Batch urls(List<String> urls) {
    this.urls = urls;
    return this;
  }

  public Batch addUrlsItem(String urlsItem) {
    this.urls.add(urlsItem);
    return this;
  }

   /**
   * URLs to download the batch
   * @return urls
  **/
  @ApiModelProperty(example = "null", value = "URLs to download the batch")
  public List<String> getUrls() {
    return urls;
  }

  public void setUrls(List<String> urls) {
    this.urls = urls;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Batch batch = (Batch) o;
    return Objects.equals(this.id, batch.id) &&
        Objects.equals(this.status, batch.status) &&
        Objects.equals(this.started, batch.started) &&
        Objects.equals(this.finished, batch.finished) &&
        Objects.equals(this.count, batch.count) &&
        Objects.equals(this.processed, batch.processed) &&
        Objects.equals(this.failed, batch.failed) &&
        Objects.equals(this.urls, batch.urls);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, status, started, finished, count, processed, failed, urls);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Batch {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    started: ").append(toIndentedString(started)).append("\n");
    sb.append("    finished: ").append(toIndentedString(finished)).append("\n");
    sb.append("    count: ").append(toIndentedString(count)).append("\n");
    sb.append("    processed: ").append(toIndentedString(processed)).append("\n");
    sb.append("    failed: ").append(toIndentedString(failed)).append("\n");
    sb.append("    urls: ").append(toIndentedString(urls)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

